package com.purui.prims.common.config;

import lombok.Data;
import org.springframework.boot.context.properties.ConfigurationProperties;
import org.springframework.context.annotation.Configuration;

/**
 * DolphinScheduler配置类
 *
 * @author charlie
 * @date 2024/7/25
 */
@Configuration
@Data
@ConfigurationProperties(prefix = "dolphinscheduler")
public class DolphinSchedulerConfig {

    private String url;

    private String token;

    private String sourceName;

    // 源端数据源类型
    private String sourceType;

    private String targetName;

    // 目标端数据源类型
    private String targetType;
}
