package com.purui.prims.common.pojo;

import lombok.Data;

import java.io.Serializable;

/**
 * 持久化的配置对象
 * @author charlie
 * @date 2024/8/1
 */
@Data
public class PersistenceConf implements Serializable {

    /**
     * 持久化周期
     */
    private String cron;

    /**
     * 持久化类型(default:物化视图,database:数据库)
     */
    private String type = "default";

    /**
     * 副本数
     */
    private int replicationNum = 3;

    /**
     * 分桶数
     */
    private int bucketSize = 20;

    /**
     * 分区字段
     */
    private String partitionKey;

}
