package com.purui.prims.headless.api.pojo;

import com.google.common.collect.Lists;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.AllArgsConstructor;
import lombok.Data;
import lombok.NoArgsConstructor;

import java.util.List;

@Data
@AllArgsConstructor
@NoArgsConstructor
@ApiModel(value = "数据集模型配置")
public class DataSetModelConfig {

    @ApiModelProperty(value = "数据集模型配置ID")
    private Long id;

    @ApiModelProperty(value = "是否包含所有")
    private Boolean includesAll = false;

    @ApiModelProperty(value = "指标ID列表")
    private List<Long> metrics = Lists.newArrayList();

    @ApiModelProperty(value = "维度ID列表")
    private List<Long> dimensions = Lists.newArrayList();

    public DataSetModelConfig(Long id, List<Long> dimensions, List<Long> metrics) {
        this.id = id;
        this.metrics = metrics;
        this.dimensions = dimensions;
    }
}
