package com.purui.prims.headless.api.pojo;

import com.purui.prims.headless.api.pojo.response.DimensionResp;
import com.purui.prims.headless.api.pojo.response.MetricResp;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;

import java.util.ArrayList;
import java.util.List;

/**
 * 模型数据
 * @author charlie
 * @date 2024/8/30
 */
@Data
@ApiModel(value = "模型信息")
public class ModelInfo {

    @ApiModelProperty(value = "模型ID")
    private Long id;

    @ApiModelProperty(value = "主题域ID")
    private Long domainId;

    @ApiModelProperty(value = "业务名称")
    private String bizName;

    @ApiModelProperty(value = "名称")
    private String name;

    @ApiModelProperty(value = "主键")
    List<Identify> identifiers = new ArrayList<>();

    @ApiModelProperty(value = "维度")
    List<DimensionResp> dimensions = new ArrayList<>();

    @ApiModelProperty(value = "度量")
    List<MetricResp> metrics = new ArrayList<>();


}
