package com.purui.prims.headless.api.pojo;

import com.purui.prims.common.pojo.JoinCondition;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;

import java.io.Serializable;
import java.util.ArrayList;
import java.util.List;

/**
 * 表关联关系
 *
 * @author charlie
 * @date 2024/7/4
 */
@Data
public class TableJoinRelation implements Serializable {

    @ApiModelProperty(value = "左表")
    String left;

    @ApiModelProperty(value = "右表")
    String right;

    @ApiModelProperty(value = "关联类型")
    String type;

    @ApiModelProperty(value = "关联条件")
    List<JoinCondition> conditions = new ArrayList<>();

    @ApiModelProperty(value = "左表字段")
    List<String> leftFields = new ArrayList<>();

    @ApiModelProperty(value = "右表字段")
    List<String> rightFields = new ArrayList<>();

}
