package com.purui.prims.headless.api.pojo;


import com.purui.prims.common.pojo.Constants;
import com.purui.prims.common.pojo.enums.TimeMode;
import io.swagger.annotations.ApiModelProperty;
import lombok.AllArgsConstructor;
import lombok.Data;
import lombok.NoArgsConstructor;

@Data
@AllArgsConstructor
@NoArgsConstructor
public class TimeDefaultConfig {


    /**
     * default time span unit
     */
    @ApiModelProperty(value = "默认时间跨度")
    private Integer unit = 1;

    /**
     * default time type: day
     * DAY, WEEK, MONTH, YEAR
     */
    @ApiModelProperty(value = "默认时间类型")
    private String period = Constants.DAY;

    @ApiModelProperty(value = "默认时间模式")
    private TimeMode timeMode = TimeMode.LAST;

}
