package com.purui.prims.headless.api.pojo.request;

import com.purui.prims.common.pojo.enums.EventType;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import java.util.List;

@Data
@ApiModel(value = "批量更新请求")
public class MetaBatchReq {

    @ApiModelProperty(value = "ID列表")
    private List<Long> ids;

    @ApiModelProperty(value = "业务名称列表")
    private List<String> bizNames;

    @ApiModelProperty(value = "模型ID列表")
    private List<Long> modelIds;

    /**
     * 最后变更的状态
     */
    @ApiModelProperty(value = "状态")
    private Integer status;

    /**
     * 批量执行分类信息
     */
    @ApiModelProperty(value = "类型")
    private EventType type;

    @ApiModelProperty(value = "分类列表")
    private List<String> classifications;

    @ApiModelProperty(value = "敏感级别")
    private Integer sensitiveLevel;

}
