package com.purui.prims.headless.api.pojo.request;

import com.google.common.collect.Lists;
import com.purui.prims.common.pojo.PageBaseReq;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;

import java.util.List;

@Data
public class PageSchemaItemReq extends PageBaseReq {

    @ApiModelProperty(value = "ID")
    private String id;

    @ApiModelProperty(value = "名称")
    private String name;

    @ApiModelProperty(value = "业务名称")
    private String bizName;

    @ApiModelProperty(value = "创建人")
    private String createdBy;

    @ApiModelProperty(value = "主题域ID列表")
    private List<Long> domainIds = Lists.newArrayList();

    @ApiModelProperty(value = "模型ID列表")
    private List<Long> modelIds = Lists.newArrayList();

    @ApiModelProperty(value = "类型")
    private String type;

    @ApiModelProperty(value = "敏感级别")
    private Integer sensitiveLevel;

    @ApiModelProperty(value = "状态")
    private Integer status;

    @ApiModelProperty(value = "关键字")
    private String key;

    @ApiModelProperty(value = "查询ID列表")
    private List<Long> ids;

    @ApiModelProperty(value = "是否收藏")
    private boolean hasCollect;

    @ApiModelProperty(value = "分类列表")
    private List<String> classifications;
}
