package com.purui.prims.headless.api.pojo.request;

import com.google.common.collect.Lists;
import com.purui.prims.common.pojo.DateConf;
import com.purui.prims.common.pojo.Filter;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import lombok.ToString;

import java.util.List;

@Data
@ToString
@ApiModel(value = "查询指标Req")
public class QueryMetricReq {

    @ApiModelProperty(value = "主题域ID")
    private Long domainId;

    @ApiModelProperty(value = "指标ID")
    private List<Long> metricIds = Lists.newArrayList();

    @ApiModelProperty(value = "指标名称")
    private List<String> metricNames = Lists.newArrayList();

    @ApiModelProperty(value = "维度ID")
    private List<Long> dimensionIds = Lists.newArrayList();

    @ApiModelProperty(value = "维度名称")
    private List<String> dimensionNames = Lists.newArrayList();

    @ApiModelProperty(value = "过滤条件")
    private List<Filter> filters = Lists.newArrayList();

    @ApiModelProperty(value = "日期信息")
    private DateConf dateInfo = new DateConf();

    @ApiModelProperty(value = "最大条数")
    private Long limit = 2000L;

}