package com.purui.prims.dscheduler.model;

import com.fasterxml.jackson.annotation.JsonFormat;
import com.purui.prims.dscheduler.enums.ReleaseState;
import lombok.Data;

import java.util.Date;
import java.util.Map;

/** task main info */
@Data
public class TaskMainInfo {

    // id
    private Long id;

    // 任务名
    private String taskName;

    // 任务编号
    private Long taskCode;

    // 任务版本
    private Integer taskVersion;

    // 任务类型
    private String taskType;

    // 创建时间
    @JsonFormat(locale = "zh", timezone = "GMT+8", pattern = "yyyy-MM-dd HH:mm:ss")
    private Date taskCreateTime;

    // 更新时间
    @JsonFormat(locale = "zh", timezone = "GMT+8", pattern = "yyyy-MM-dd HH:mm:ss")
    private Date taskUpdateTime;

    // 工作流编号
    private Long processDefinitionCode;

    // 工作流编号
    private Integer processDefinitionVersion;

    // 工作流名
    private String processDefinitionName;

    // 状态
    private ReleaseState processReleaseState;

    // 前置任务集合
    private Map<Long, String> upstreamTaskMap;

    // 前置任务编号
    private Long upstreamTaskCode;

    // 前置名
    private String upstreamTaskName;
}
