package com.purui.prims.headless.server.persistence.dataobject;

import com.baomidou.mybatisplus.annotation.IdType;
import com.baomidou.mybatisplus.annotation.TableField;
import com.baomidou.mybatisplus.annotation.TableId;
import com.baomidou.mybatisplus.annotation.TableName;

import java.util.Date;

import lombok.Getter;
import lombok.Setter;

/**
 * <p>
 * 持久化数据
 * </p>
 *
 * @author charlie
 * @since 2024-07-09
 */
@Getter
@Setter
@TableName("pr_persistence_info")
public class PersistenceInfoDO {

    /**
     * 主键
     */
    @TableId(value = "id", type = IdType.AUTO)
    private Long id;

    /**
     * 编码
     */
    @TableField("`code`")
    private String code;

    /**
     * 名称
     */
    @TableField("`name`")
    private String name;

    /**
     * 持久化后编码
     */
    private Long persistentCode;

    /**
     * workflow/task
     */
    @TableField("`type`")
    private String type;

    /**
     * 创建日期
     */
    private Date createdAt;

    /**
     * 创建人
     */
    private String createdBy;

    /**
     * 更新日期
     */
    private Date updatedAt;

    /**
     * 更新人
     */
    private String updatedBy;


}
