package com.purui.prims.headless.server.persistence.dataobject;

import com.baomidou.mybatisplus.annotation.IdType;
import com.baomidou.mybatisplus.annotation.TableField;
import com.baomidou.mybatisplus.annotation.TableId;
import com.baomidou.mybatisplus.annotation.TableName;
import lombok.Getter;
import lombok.Setter;

/**
 * 角色权限表
 *
 * @author charlie
 * @since 2024-07-05
 */
@Getter
@Setter
@TableName("pr_role_auth")
public class RoleAuthDO {

    /**
     * 主键
     */
    @TableId(value = "id", type = IdType.AUTO)
    private Integer id;

    /**
     * 角色ID
     */
    private Integer roleId;

    /**
     * 数据类型(ItemType:主题域/指标/维度)
     */
    private String dataType;

    /**
     * 数据ID
     */
    private Long dataId;

    /**
     * 权限类型(编辑/管理/发布)
     */
    private String authType;

    /**
     * 状态
     */
    @TableField("`status`")
    private Boolean status;


}
